# Rules for VC8

INIT_DEFAULT_OUTPUT = Makefile.vc8
INIT_KEYWORDS       = win32 bcc32

CXX = cl /nologo
RM = del /nologo

### Standard Application
begin app
OUTPUT_$(NAME) := $(NAME).exe
OBJECT_EXT     := obj

$(OUTPUT): $(OBJECTS) $(OUTPUT_$(DEPEND)) $(LIBDEPEND)
        link /force:multiple $(LDFLAGS) $(LINKFLAGS_$(DEPEND)) /out:$(OUTPUT) $(OBJECTS) $(LINK_$(DEPEND)) $(LIBS)

clean:
	$(RM) $(OBJECTS)

distclean:
        $(RM) $(OUTPUT)

ALL_TARGETS += $(OUTPUT)
end


### Static Library
begin lib
OUTPUT_$(NAME) := $(NAME).lib
OBJECT_EXT     := obj
LINK_$(NAME)   := $(OUTPUT)

$(OUTPUT): $(OBJECTS) $(OUTPUT_$(DEPEND))
        lib /out:$(OUTPUT) $(OBJECTS) $(OUTPUT_$(DEPEND))

distclean:
        $(RM) $(OUTPUT)

clean:
	$(RM) $(OBJECTS)

ALL_TARGETS += $(OUTPUT)
end


### Subproject
begin subproject
OBJECT_EXT     := obj
OUTPUT_$(NAME) := $(OBJECTS) $(OUTPUT_$(DEPEND))
LINK_$(NAME)   := $(OBJECTS) $(LINK_$(DEPEND))

clean:
        $(RM) $(OBJECTS)
end


### Prebuilt library
# Note: the use of "LINKFLAGS" is a special-purpose hack. We should
# have a way to postprocess "LINK" somehow to separate options and
# libraries for compilers that need it.
begin prebuilt-lib
OUTPUT_$(NAME) :=
LINK_$(NAME) := $(NAME).lib
LINKFLAGS_$(NAME) := /LIBPATH:$(LIBDIR)
end


### Basic Rules

# C compiler:
.c.obj:
	$(CC) $(CFLAGS) /Fo$@ /c /Tc$<

# C++ compiler:
.cc.obj:
	$(CXX) $(CXXFLAGS) /Fo$@ /c /Tp$<

.cpp.obj:
	$(CXX) $(CXXFLAGS) /Fo$@ /c /Tp$<

# Administrativa:
distclean: clean

.PHONY: all clean distclean

# Win32 stuff:
# mklib.exe: mklib.c
#	$(CXX) /Fe$@ $<
